$regfile = "attiny25.dat"
$noramclear
$crystal = 1000000
Config Watchdog = 2048
Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinb.2 = Input
Config Pinb.3 = Input
Config Pinb.4 = Input
Config Timer0 = Timer , Prescale = 1024

Set Portb.0
Set Portb.1
Set Portb.2
Set Portb.3
Set Portb.4

Dim Odl_sek As Byte
Dim Czas1 As Long
Dim Czas2 As Long
Dim Godz1 As Byte
Dim Godz2 As Byte
Dim Zez_c1 As Bit
Dim Zez_c2 As Bit
Dim Flaga1 As Bit
Dim Zezw1 As Bit
Dim Zezw2 As Bit

Declare Sub Sygn
Declare Sub Przyc1
Declare Sub Przyc2

On Timer0 Odlicz

Enable Interrupts
Enable Timer0
Load Timer0 , 252

Readeeprom Godz1 , 1
Readeeprom Godz2 , 2
If Godz1 = 255 Then
  Godz1 = 0
  Writeeeprom Godz1 , 1
End If
If Godz2 = 255 Then
  Godz2 = 0
  Writeeeprom Godz2 , 2
End If

Odl_sek = 0
Zezw1 = 0
Zezw2 = 0
Godz1 = 0
Godz2 = 0
Zez_c1 = 0
Zez_c2 = 0

If Pinb.3 = 0 Then                                          'Programowanie przycisku S1
  Reset Portb.0
  Writeeeprom Godz1 , 1
  Do
   Bitwait Pinb.3 , Set
   Waitms 50
   Bitwait Pinb.3 , Reset
   If Pinb.3 = 0 Then
    Incr Godz1
    Call Sygn
    If Godz1 = 25 Then
     Godz1 = 0
    End If
    Writeeeprom Godz1 , 1
   End If
  Loop Until Godz1 = 0
  Reset Portb.1
  Wait 1
  Set Portb.1
End If

If Pinb.4 = 0 Then                                          ' Programowanie przycisku S2
  Reset Portb.0
  Godz2 = 0
  Writeeeprom Godz2 , 2
  Do
   Bitwait Pinb.4 , Set
   Waitms 50
   Bitwait Pinb.4 , Reset
   If Pinb.4 = 0 Then
    Incr Godz2
    Call Sygn
    If Godz2 = 25 Then
     Godz2 = 0
    End If
    Writeeeprom Godz2 , 2
   End If
  Loop Until Godz2 = 0
  Reset Portb.1
  Wait 1
  Set Portb.1
End If

Readeeprom Godz1 , 1                                        ' Odczyt ustawien z pamieci EEPROM
Readeeprom Godz2 , 2
Czas1 = Godz1 * 3600
Czas2 = Godz2 * 3600

If Godz1 <> 0 Then                                          ' Zezwolenie na odliczanie zadanego czasu
 Zez_c1 = 1
End If
If Godz2 <> 0 Then
 Zez_c2 = 1
End If


Do
 Do
  Portb.0 = Not Portb.0                                     'Obsluga alarmow
  Waitms 100
 Loop Until Godz1 <> 0 Or Godz2 <> 0
Loop Until Pinb.3 = 0 Or Pinb.4 = 0
Set Portb.0
Start Timer0
Do
 Flaga1 = 1
 If Zezw1 = 1 And Zezw2 = 1 Then
  Flaga1 = 0
  Call Przyc1
  Call Przyc2
  Call Sygn
  Call Sygn
  Call Sygn
  Call Przyc1
  Call Przyc2
  Wait 1
  Call Przyc1
  Call Przyc2
 End If
 If Flaga1 = 1 And Zezw1 = 1 Then
  Flaga1 = 0
  Call Sygn
  Call Przyc1
  Wait 1
  Call Przyc1
 End If
 If Flaga1 = 1 And Zezw2 = 1 Then
  Flaga1 = 0
  Call Przyc2
  Call Sygn
  Call Przyc2
  Call Sygn
  Call Przyc2
  Wait 1
 End If
 Idle
Loop
End

Sub Sygn                                                    'Obsluga sygnalizatora akustycznego oraz diody LED
 Reset Portb.0
 Reset Portb.1
 Waitms 150
 Set Portb.0
 Set Portb.1
End Sub

Sub Przyc1                                                  'Obsluga przycisku S1
 If Pinb.3 = 0 Then
  Zezw1 = 0
  Czas1 = Godz1 * 3600
  If Czas1 <> 0 Then
   Zez_c1 = 1
  End If
 End If
End Sub

Sub Przyc2                                                  'Ogsluga przycisku S2
 If Pinb.4 = 0 Then
  Zezw2 = 0
  Czas2 = Godz2 * 3600
  If Czas2 <> 0 Then
   Zez_c2 = 1
  End If
 End If
End Sub

Odlicz:                                                     'Odliczanie zadanego czasu dla kanalow 1 oraz 2
 Load Timer0 , 252
 Incr Odl_sek
 If Odl_sek = 5 Then
  Odl_sek = 0
  If Zez_c1 = 1 Then
   Decr Czas1
   If Czas1 = 0 Then
    Zez_c1 = 0
    Zezw1 = 1
    Call Przyc1
   End If
  End If
  If Zez_c2 = 1 Then
   Decr Czas2
   If Czas2 = 0 Then
    Zez_c2 = 0
    Zezw2 = 1
    Call Przyc2
   End If
  End If
End If
Return