'Modul wykonawczy termostatu
'Ukad slave sieci RS485.
'Predkosc komunikacji 9600 bodw
'Fuse bit A987 ustawione na wartosc 1111 (zewnetrzny rezonator kwarcowy)
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw wykorzystywanego mikrontrolera
$crystal = 8000000                                          'informuje kompilator o czestotliwosci rezonatora kwarcowego
$baud = 9600                                                'informuje kompilator o predkosci transmisji RS232
$framesize = 50                                             'wielkosc ramki
$hwstack = 50                                               'wielkosc stosu sprzetowego
$swstack = 50                                               'wielkosc stosu programowego

Config Pinc.0 = Output                                      'linia pc.0 jako wyjscie
Config Pinb.0 = Output                                      'linia pb.0 jako wyjscie
Config Pinb.1 = Input                                       'linia pb.1 jako wejscie
Config Pinb.2 = Input                                       'linia pb.2 jako wejscie
Config Pinb.3 = Input                                       'linia pb.3 jako wejscie
Config Pinb.4 = Input                                       'linia pb.4 jako wejscie
Config Pinb.5 = Input                                       'linia pb.5 jako wejscie
Config Pind.2 = Output                                      'linia pd.2 jako wyjscie
Config Serialin = Buffered , Size = 15                      'konfiguracja by interfejs rs232 uzywal przy odbiorze transmisji buforowej (bufor o wielkosci 15 znakow)
Config Watchdog = 1024                                      'konfiguracja watchdoga

Dim Adr As Byte                                             'zmienna adresu modulu
Dim Zn As String * 1                                        'zmienna przecowujaca odebrany znak z rs232
Dim Zm_lan As String * 3                                    'zmienna w ktorej skladany jest w calosc otrzymany adres oraz dane o szerokosci impulsu PWM
Dim Adres As Byte                                           'zmienna ktora przechowuje przekonwertowany na dziesietnie otrzymany adres
Dim Il_zn As Byte                                           'zmienna liczy ilosc otrzymanych znakow przy skladaniu adresu
Dim St_pk1 As Byte                                          'przechowuje tymczasowo stan przekaznika pk1

Re_de Alias Portd.2                                         'przypisanie aliasu linii pd.2, re_de steruje kierunkiem transmisji konwertera
Pk Alias Portc.0                                            'przypisanie aliasu pk linii pc.0
Led Alias Portb.0                                           'przypisanie aliasu led linii pb.0

Set Portb.1                                                 'wlaczenie rezystora podcigajacego linii pb.1
Set Portb.2                                                 'wlaczenie rezystora podcigajacego linii pb.2
Set Portb.3                                                 'wlaczenie rezystora podcigajacego linii pb.3
Set Portb.4                                                 'wlaczenie rezystora podcigajacego linii pb.4
Set Portb.5                                                 'wlaczenie rezystora podcigajacego linii pb.5

Enable Interrupts                                           'odblokowanie globalnych przerwan
Reset Re_de                                                 'przelaczenie konwertera rs485 na odbiornik
Reset Pk                                                    'wylaczenie pk
Set Led                                                     'wylaczenie led
Reset Watchdog                                              'zerowanie watchdoga
Start Watchdog                                              'start watchdoga

Do                                                          'poczatek petli programu
  Reset Watchdog                                            'zerowanie watchdoga
  Zn = Inkey()                                              'odczyt znaku z portu rs232
  If Zn = Chr(8) Then                                       'jesli otrzymany znak to BS (backspace - kod ascii 8) to
    Zm_lan = ""                                             'czysc zmienna zn_lan
    Il_zn = 0                                               'oraz zeruj zmienna il_zn
    Do                                                      'poczatek petli do-loop
      Reset Watchdog                                        'zerowanie watchdoga
      Zn = Inkey()                                          'odczyt znaku z portu rs232
      If Zn >= "0" And Zn <= "9" Then                       'jesli otrzynany znak jest cyfra (0..9) to
        Incr Il_zn                                          'zwieksz o jeden il_zn
        Zm_lan = Zm_lan + Zn                                'dodaj otrzymany znak cyfry do zmiennej zm_lan
      Else                                                  'w przeciwnym razie
        If Zn > Chr(0) Then                                 'jesli otrzymany znak ma kod ascii wiekszy od 0 to
          Exit Do                                           'opusc petle do-loop
        End If
      End If
    Loop                                                    'koniec wewnetrznej petli do-loop
    If Il_zn > 0 And Il_zn < 3 Then                         'jesli il_zn wynosi 1 lub 2 to
      Reset Watchdog                                        'zerowanie watchdoga
      Adres = Val(zm_lan)                                   'zamien znakowa wartosc otrzymanego adresu na postac liczbowa i umiesc ja w adres
      Adr = Pinb And &B00111110                             'odczyt adresu modulu
      Shift Adr , Right , 1                                 'obliczenie adresu modulu
      Adr = 31 - Adr                                        'dalsze obliczenie adresu modulu
      If Adres = Adr Then                                   'jesli otrzymany adres od mastera rowna sie adresowi tego modulu oraz
        If Zn = "r" Then                                    'jesli nastepny otrzymany znak to "r"
          Do                                                'poczatek wewnetrznej petli do-loop
            Reset Watchdog                                  'zerowanie watchdoga
            Zn = Inkey()                                    'odczyt znaku z portu rs232
          Loop Until Zn > Chr(0)                            'opusc petle gdy otrzymany znak wiekszy od kodu 0 ascii
          If Zn = "p" Then                                  'jesli otrzymano znak "p" to
            Do                                              'poczatek wewnetrznej petli do-loop
              Reset Watchdog                                'zerowanie watchdoga
              Zn = Inkey()                                  'odczyt znaku z portu rs232
            Loop Until Zn = Chr(13)                         'jesli otrzymany znak to cr - enter (kod ascii 13) to
            St_pk1 = Pk                                     'zapisz do st_pk1 stan przekaznika pk
            Set Re_de                                       'przelaczenie konwertera rs485 na nadajnik
            Waitus 200                                      'czekaj 200 us
            Print St_pk1                                    'wyslij stan przekaznika
            Waitms 1                                        'czekaj 1 ms
            Reset Re_de                                     'przelaczenie konwertera rs485 na odbiornik
          End If
        End If
        If Zn = "w" Then                                    'jesli otrzymany znak to "w"
          Do                                                'poczatek wewnetrznej petli do-loop
            Reset Watchdog                                  'zerowanie watchdoga
            Zn = Inkey()                                    'odczyt znaku z portu rs232
          Loop Until Zn > Chr(0)                            'opusc petle gdy otrzymany znak wiekszy od kodu 0 ascii
          If Zn = "p" Then                                  'jesli otrzymano znak "p" to
            Il_zn = 0                                       'zeruj zmienna il_zn
            Do                                              'poczatek wewnetrznej petli do-loop
              Reset Watchdog                                'zerowanie watchdoga
              Zn = Inkey()                                  'odczyt znaku z portu rs232
              If Zn = "0" Or Zn = "1" Then                  'jesli otrzymano znak o wartosci 0 lub 1 to
                Incr Il_zn                                  'zwieksz o jeden il_zn
                St_pk1 = Asc(zn)                            'zapisz zamieniona na postac cyfrowa znak do zmiennej stanu przekaznika st_pk1
              Else                                          'w przeciwnym razie
                If Zn > Chr(0) Then                         'jesli otrzymany znak ma kod ascii wiekszy od 0 to
                  Exit Do                                   'opusc petle do-loop
                End If
              End If
              Reset Watchdog                                'zerowanie watchdoga
            Loop                                            'koniec wewnetrznej petli do-loop
            If Il_zn = 1 And Zn = Chr(13) Then              'jesli il_zn rowne 1 oraz otrzymano znak CR (ascii 13) to
              Reset Watchdog                                'zerowanie watchdoga
              Pk = St_pk1.0                                 'nadanie stanu najmlodszego bitu st_pk1 linii portu sterujacej przekaznikiem pk1
              Led = St_pk1.0                                'jesli przekaznik zalaczony to zalaczenie diody LED
              Toggle Led                                    'zalaczenie diody led
            End If
          End If
        End If
      End If
    End If
  End If
Loop                                                        'koniec glownej petli do-loop
End                                                         'koniec programu