'Modul sterownika termostatu
'Ukad master sieci RS485.
'Predkosc komunikacji 9600 bodw
'Fuse bit A987 ustawione na wartosc 1111 (zewnetrzny rezonator kwarcowy)
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw wykorzystywanego mikrontrolera
$crystal = 8000000                                          'informuje kompilator o czestotliwosci rezonatora kwarcowego
$baud = 9600                                                'informuje kompilator o predkosci transmisji RS232
$framesize = 60                                             'wielkosc ramki
$hwstack = 60                                               'wielkosc stosu sprzetowego
$swstack = 60                                               'wielkosc stosu programowego

Config Pinb.4 = Output                                      'linia DATA jako wyjciowa
Config Pinb.5 = Output                                      'linia CLK jako wyjciowa
Config Pinb.2 = Output                                      'linia CS jako wyjciowa
Config Pind.5 = Input                                       'linia jako wejscie
Config Pind.6 = Input                                       'linia jako wejscie
Config Pind.7 = Input                                       'linia jako wejscie
Config Pinb.0 = Input                                       'linia jako wejscie
Config Pind.2 = Output                                      'linia pd.2 jako wyjscie
Config Lcd = 16 * 1a                                        'konfiguracja organizacji znakow wyswietlacza LCD
Config Lcdpin = Pin , Db4 = Portc.4 , Db5 = Portc.3 , Db6 = Portc.2 , Db7 = Portc.1 , E = Portc.5 , Rs = Portb.3       'konfiguracja pinow mikrokontrolara do
Config Adc = Single , Prescaler = Auto , Reference = Avcc   'konfiguracja wewnetrznego przetwornika
Config Serialin = Buffered , Size = 15                      'konfiguracja by interfejs rs232 uzywal przy odbiorze transmisji buforowej (bufor o wielkosci 15 znakow)
Config 1wire = Portc.0                                      'konfiguracja magistrali 1wire
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Disconnect , Prescale = 8       'konfiguracja generatora PWM
Config Watchdog = 1024                                      'konfiguracja watchdoga

Declare Sub Odczyt_zn                                       'procedura odczytu otrzymanych danych od ukladow slave
Declare Sub Zapisz_vfd(byval Wart As Byte)                  'zapisuje wartosc do vfd
Declare Sub Jasn_zn(byval Js As Byte)                       'umoliwia wybr jasnoci
Declare Sub Poz_kurs(byval Poz As Byte)                     'wybor pozycji kursora
Declare Sub Wys_vfd(byval S As String)                      'wyswietla string
Declare Sub Czysc()                                         'czyci wywietlacz oraz
Declare Sub Pocz()                                          'ustawia kursor na pocztku
Declare Sub Znak_uz(byval Nr_zn As Byte , Byval Kol1 As Byte , Byval Kol2 As Byte , Byval Kol3 As Byte , Byval Kol4 As Byte , Byval Kol5 As Byte)       'zapisuje do vfd znak uzytkownika
Declare Sub Wys_zm_vfd                                      'wysyla zmienna do vfd
Declare Sub Wys_st                                          'wyswietla stopien C

Dim K As Byte                                               'zmienna licznikowa
Dim Kod As Byte                                             'zmienna przechowujca
Dim M As Byte                                               'zmienna licznikowa
Dim Hist As Byte                                            'histereza
Dim Podsw As Byte                                           'podswietlenie
Dim Temp_ust As Byte                                        'ustawiona temperatura termostatu
Dim Zn As String * 1                                        'zmienna przecowujaca odebrany znak z rs232
Dim Zm_lan As String * 5                                    'zmienna w ktorej skladany jest w calosc otrzymany adres
Dim St_pk1 As Byte                                          'przechowuje stan przekaznika pk1
Dim St_pk2 As Byte                                          'przechowuje stan przekaznika pk2
Dim Czekaj As Word                                          'zmienna liczaca czas na odpowiedz ukladow slave
Dim Temp_odcz As Integer                                    'zmienna przechowujaca odczytana temperature od slave 1
Dim Temp_komp(2) As Integer                                 'zmienna przechowujaca odczytana temperature od slave 1
Dim Temp_pom1 As Integer                                    'zmienna przechowuje obliczana temperature przy realizacji termostatu
Dim I As Byte                                               'zmienna licznikowa
Dim Tmp_termost As Byte                                     'temp termostatu
Dim Adr_mod_wyk As Byte                                     'adres uklady wyk
Dim Adr_mod_tw As Byte                                      'adres ukladu temp1
Dim Adr_mod_tz As Byte                                      'adres ukladu temp2
Dim B As Byte                                               'zmienna pomocnicza
Dim Temp_pom As Single                                      'zmienna pomiaru temperatury przez LM335
Dim Temp_zm As Integer                                      'przechowuje zmierzona temperature
Dim Temp_ds(2) As Byte                                      'tablica na wynik pomiaru przez DS18B20
Dim Tmp_ds As Integer                                       'zmienna pomocnicza przy obliczeniu temperatury z DS18B20
Dim Temp As Word                                            'zmienna pomocnicza
Dim Wart_zm As Word                                         'wartosc zmierzonej temp
Dim J As Byte                                               'zmienna pomocnicza
Dim Licznik As Word                                         'zmienna licznikowa
Dim U_par As Bit                                            'flaga zezwolenia konfiguracje termostatu
Dim Z_lcd As Bit                                            'flaga zezwolenia na aktualizacje wyswietlacza
Dim Tab_zm(6) As Byte                                       'tablica pomocnicza podczas konfiguracji termostatu

Re_de Alias Portd.2                                         'przypisanie aliasu linii pd.2, re_de steruje kierunkiem transmisji konwertera
S1 Alias Pind.7                                             'przypisanie aliasu S1 (dolaczony przycisk S1) linii pd.7
Zw Alias Pinb.0                                             'przypisanie aliasu zw linii pb.0
Cs Alias Portb.5                                            'przypisanie do linii PB5 (CS)

Set Portb.0                                                 'dolaczenie do linii wejsciowej d.0 rezystora podciagajacego
Set Portd.7                                                 'dolaczenie do linii wejsciowej d.7 rezystora podciagajacego
Set Portd.6                                                 'dolaczenie do linii wejsciowej d.6 rezystora podciagajacego
Set Portd.5                                                 'dolaczenie do linii wejsciowej d.5 rezystora podciagajacego
Set Portb.5                                                 'dolaczenie do linii wejsciowej b.5 rezystora podciagajacego

Reset Watchdog                                              'zerowanie watchdog
Deflcdchar 0 , 8 , 4 , 19 , 32 , 14 , 14 , 14 , 14          'definicja znaku rozlaczonego przekaznika
Deflcdchar 1 , 32 , 32 , 31 , 32 , 14 , 14 , 14 , 14        'definicja znaku zalaczonego przekaznika
Deflcdchar 2 , 2 , 5 , 2 , 32 , 32 , 32 , 32 , 32           'definicja znaku stopnia
Cls                                                         'czysc LCD
Set Cs                                                      'zablokowanie komunikacji z vfd
Waitms 100                                                  'opnienie 100 ms
Reset Cs                                                    'odblokowanie komunikacji z fvd
Call Zapisz_vfd(&Hf7)                                       'czstotliwo odwieania vfd
Call Zapisz_vfd(&H07)                                       'dlugosc wyswietlacza vfd
Call Zapisz_vfd(&Hf5)                                       'cykl 320 us
Call Zapisz_vfd(&Hf1)                                       'wlaczenie vfd
Reset Watchdog                                              'zerowanie watchdog
Znak_uz 0 , 0 , 0 , 64 , 160 , 64                           'definicja znaku stopnia dla vfd
Znak_uz 1 , 32 , 143 , 79 , 47 , 32                         'definicja znaku rozlaczonego przekaznika dla vfd
Znak_uz 2 , 32 , 47 , 47 , 47 , 32                          'definicja znaku stopnia dla vfd

Start Adc                                                   'uruchamia wbudowany przetwornik A/C
Enable Interrupts                                           'odblokowanie globalnych przerwan
Reset Watchdog                                              'zerowanie watchdog
Start Watchdog                                              'start watchdog
St_pk1 = 0                                                  'zeruje zmienna okreslajaca stan przekaznika pk
Reset U_par                                                 'zerowanie flagi
Cursor Off                                                  'kursor lcd wylaczony
Cls                                                         'czysc LCD
Czysc                                                       'czysc vfd
Tmp_termost = 1                                             'temperatura dla term 1=w, 2=z
Adr_mod_wyk = 1                                             'adres uklady wyk
Adr_mod_tw = 32                                             'adres ukladu temp wew
Adr_mod_tz = 4                                              'adres ukladu temp zew
Hist = 1                                                    'histereza
Podsw = 5                                                   'poziom podswietlenia
Temp_ust = 25                                               'temperatura termostatu

Readeeprom B , 1                                            'odczyt z pamieci eeprom
If B = 255 Then                                             'jesli B=255 to
  B = 5                                                     'przypisanie b wartosci 5
  Writeeeprom B , 1                                         'zapis danej do pamieci eeprom
  Writeeeprom Temp_ust , 2                                  'zapis danej do pamieci eeprom
  Writeeeprom Adr_mod_tw , 3                                'zapis danej do pamieci eeprom
  Writeeeprom Adr_mod_tz , 4                                'zapis danej do pamieci eeprom
  Writeeeprom Adr_mod_wyk , 5                               'zapis danej do pamieci eeprom
  Writeeeprom Tmp_termost , 6                               'zapis danej do pamieci eeprom
  Writeeeprom Hist , 7                                      'zapis danej do pamieci eeprom
  Writeeeprom Podsw , 8                                     'zapis danej do pamieci eeprom
End If
Reset Watchdog                                              'zerowanie watchdog
Readeeprom Temp_ust , 2                                     'odczyt z pamieci eeprom
Readeeprom Adr_mod_tw , 3                                   'odczyt z pamieci eeprom
Readeeprom Adr_mod_tz , 4                                   'odczyt z pamieci eeprom
Readeeprom Adr_mod_wyk , 5                                  'odczyt z pamieci eeprom
Readeeprom Tmp_termost , 6                                  'odczyt z pamieci eeprom
Readeeprom Hist , 7                                         'odczyt z pamieci eeprom
Readeeprom Podsw , 8                                        'odczyt z pamieci eeprom
Pwm1a = Podsw * 31                                          'zapis wartosci pwm dla podswietlenia lcd
Jasn_zn Podsw                                               'jasnosc wyswietlacza vfd
Reset Watchdog                                              'zerowanie watchdog
Do                                                          'poczatek glownej petli programu
  Debounce S1 , 0 , P_s1 , Sub                              'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
  Reset Watchdog                                            'zerowanie watchdog
  Temp_odcz = 0                                             'zerowanie zmiennej
  If Adr_mod_tw < 32 Then                                   'jesli adres < 32 to
    Set Re_de                                               'przelaczenie konwertera rs485 na nadajnik
    Waitms 1                                                'czekaj 1ms
    Print "{008}" ;                                         'wyslanie znaku poczatku ramki
    Print Adr_mod_tw ;                                      'wyslanie adresu
    Print "r"                                               'wysyla do slave rozkaz rzadania otrzymania zmierzonej temperatury
    Waitms 1                                                'czekaj 1ms
    Reset Re_de                                             'przelaczenie konwertera rs485 na odbiornik
    Call Odczyt_zn                                          'wywolanie procedury odczytu znakow od slave
    Temp_zm = Val(zm_lan)                                   'zamiana odczytanej temperatury (znakowo) na posta numeryczna
  Else
    Reset Watchdog                                          'zerowanie watchdog
    Czekaj = 0                                              'zerowanie zmiennej
    If Zw = 0 Then                                          'jesli zw=0 to
      Temp = 0                                              'zerowanie temp
      For I = 1 To 10                                       'petla wykonywana 5 razy
        Wart_zm = Getadc(0)                                 'pomiar napiecia na wejciu PC0 mikrokontrolera
        Temp = Temp + Wart_zm                               'Dodanie Kolejnego Pomiaru
        Debounce S1 , 0 , P_s1 , Sub                        'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
        Waitms 50                                           'opoznienie 50 ms
        Reset Watchdog                                      'zerowanie watchdog
        Debounce S1 , 0 , P_s1 , Sub                        'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
      Next I                                                'zwieksz o 1 zmienna I
      Temp = Temp / 10                                      'obliczenie sredniej temperatury
      Temp_pom = Temp * 0.48828125                          'obliczenie temperatury
      Temp_zm = Round(temp_pom)                             'zaokraglenie temperatury
      Temp_zm = Temp_zm - 273                               'przeliczenie Kelwinow na stopnie C
      If Temp_zm > 200 Then                                 'jesli zmienna > od 200 to
        Temp_zm = 200                                       'zapisanie do niej wartosci 200
      End If
    Else                                                    'w przeciwnym razie
      Reset Watchdog                                        'zerowanie watchdog
      1wreset                                               'zerowanie magistrali 1wire
      1wwrite &HCC                                          'przeskoczenie numeru ukladu DS
      1wwrite &H44                                          'start pomiaru
      For I = 1 To 15                                       'petla wykonywana 5 razy
        Debounce S1 , 0 , P_s1 , Sub                        'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
        Waitms 50                                           'czekaj 50 ms
        Reset Watchdog                                      'zerowanie watchdog
        Debounce S1 , 0 , P_s1 , Sub                        'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
      Next I                                                'zwieksz o 1 zmienna I
      1wreset                                               'zerowanie magistrali 1wire
      1wwrite &HCC                                          'przeskoczenie numeru ukladu DS
      1wwrite &HBE                                          'rozkaz odczytu temperatury
      Temp_ds(1) = 1wread(2)                                'odczyt temperatury
      Tmp_ds = Temp_ds(2)                                   'obliczenie temperatury
      Shift Tmp_ds , Left , 8                               'dalsze obliczenia
      Tmp_ds = Tmp_ds + Temp_ds(1)                          'dalsze obliczenia
      Temp_zm = Tmp_ds / 16                                 'dalsze obliczenia
    End If
  End If
  Temp_komp(1) = Temp_zm                                    'przelaczenie konwertera rs485 na odbiornik
  Reset Watchdog                                            'zerowanie watchdog
  Home                                                      'kursor na poczatej pierwszej linii LCD
  Pocz                                                      'poczatek wyswietlacza vfd
  If Czekaj > 250 Then                                      'jesli czekaj > 250 to
    Lcd "W:?     "                                          'wyswietlenie na lcd napisu
    Wys_vfd "W:?     "                                      'to samo ale na vfd
  Else                                                      'w przeciwnym razie
    Lcd "W:" ; Temp_zm ; Chr(2) ; "C "                      'wyswietlenie otrzymanej od slave 1 temperatury z dodatkowym znakiem stopnia
    Wys_vfd "W:"                                            'To Samo Dla Vfd
    Zm_lan = Str(temp_zm)                                   'przeliczenie wartosci
    Wys_st                                                  'wyslanie do vfd
  End If
  Debounce S1 , 0 , P_s1 , Sub                              'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
  Reset Watchdog                                            'zerowanie watchdog
  Waitms 50                                                 'opoznienie 50 ms
  Debounce S1 , 0 , P_s1 , Sub                              'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
  Temp_odcz = 0                                             'zerowanie zmiennej
  Set Re_de                                                 'przelaczenie konwertera rs485 na nadajnik
  Waitms 1                                                  'czekaj 1ms
  Print "{008}";                                            'wyslanie znaku poczatku ramki
  Print Adr_mod_tz ;                                        'adres ukladu
  Print "r"                                                 'wysyla do slave rozkaz rzadania otrzymania zmierzonej temperatury
  Waitms 1                                                  'czekaj 1ms
  Reset Re_de                                               'przelaczenie konwertera rs485 na odbiornik
  Call Odczyt_zn                                            'wywolanie procedury odczytu znakow od slave
  Temp_odcz = Val(zm_lan)                                   'zamiana odczytanej temperatury (znakowo) na posta numeryczna
  Temp_komp(2) = Temp_odcz                                  'zaladowanie temp do tablicy
  Temp_pom = Temp_ust - Hist                                'obliczenie temp_pom poprzez odjecie od temperatury zadanej wartosci histerezy
  Locate 2 , 1                                              'pozycja kursora dla lcd
  Reset Watchdog                                            'zerowanie watchdog
  Poz_kurs 9                                                'pozycja kursora dla vfd
  If Czekaj > 250 Then                                      'jesli czekaj wieksze od 250 to
    Lcd "Z:?     "                                          'wyswietlenie napisu na lcd
    Wys_vfd "Z:?     "                                      'wyswietlenie na vfd
  Else                                                      'w przeciwnym razie
    Lcd "Z:" ; Temp_odcz ; Chr(2) ; "C "                    'wyswietlenie otrzymanej od slave temperatury z dodatkowym znakiem stopnia
    Wys_vfd "Z:"                                            'to samo dla vfd
    Zm_lan = Str(temp_odcz)                                 'obliczenie wartosci
    Wys_st                                                  'wyslanie do vfd
  End If
  Temp_pom1 = Temp_ust - Hist                               'obliczenie temp_pom poprzez odjecie od temperatury zadanej wartosci histerezy
  If Temp_komp(tmp_termost) <= Temp_pom1 Then               'jesli temp_odcz mniejsza lub rowna temp_pom1 to
    St_pk1 = 1                                              'zalaczenie przekaznika pk1
  Else                                                      'w przeciwnym razie
    Temp_pom1 = Temp_ust + Hist                             'obliczenie temp_pom poprzez dodanie do temperatury zadanej wartosci histerezy
    If Temp_komp(tmp_termost) >= Temp_pom1 Then             'jesli temp_odcz wieksza lub rowna temp_pom to
      St_pk1 = 0                                            'wyaczenie przekaznika pk1
    End If
  End If
  Reset Watchdog                                            'zerowanie watchdog
  Set Re_de                                                 'przelaczenie konwertera rs485 na nadajnik
  Waitms 1                                                  'czekaj 1ms
  Print "{008}" ;                                           'wyslanie znaku poczatku ramki
  Print Adr_mod_wyk ;                                       'wyslanie adresu
  Print "wp" ; St_pk1                                       'wysyla do ukladu slave aktualny stan przekaznika pk1
  Waitms 1                                                  'czekaj 1ms
  Reset Re_de                                               'zerowanie linii Re_de
  Delay                                                     'opoznienie
  Set Re_de                                                 'przelaczenie konwertera rs485 na nadajnik
  Waitms 1                                                  'czekaj 1ms
  Print "{008}" ;                                           'wyslanie znaku poczatku ramki
  Print Adr_mod_wyk ; "rp"                                  'odczytuje od slave stan przekaznika pk1
  Waitms 1                                                  'czekaj 1ms
  Reset Re_de                                               'przelaczenie konwertera rs485 na odbiornik
  Call Odczyt_zn                                            'wywolanie procedury odczytu znakow od slave
  Locate 2 , 8                                              'kursor w linii 2 i na pozycji 8 LCD
  Poz_kurs 16                                               'to samo dla vfd
  Zn = Mid(zm_lan , 1 , 1)                                  'odczyt stanu pk1
  St_pk2 = Val(zn)                                          'zamiana znakowej postaci stanu PK1 na postac numeryczna i zapis jej do zmiennej st_pk1
  Reset Watchdog                                            'zerowanie watchdog
  If Czekaj > 250 Then                                      'jesli czekaj wieksze od 250 to
    Lcd "?"                                                 'wyswietl na lcd ? - brak odczytanego stanu przekaznikow PK1
    Wys_vfd "?"                                             'to samo dla vfd
  Else                                                      'w przeciwnym razie
    Lcd Chr(st_pk2)                                         'wyswietlenie znaku przekaznika
    J = 145 + St_pk2                                        'to samo dla vfd
    Zapisz_vfd J                                            'wyswietlenie graficznej reprezentacji odczytanej wartosci stanu pk1 dla vfd
  End If
  Debounce S1 , 0 , P_s1 , Sub                              'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
  Reset Watchdog                                            'zerowanie watchdog
  Waitms 50                                                 'czekaj 50 ms
  Debounce S1 , 0 , P_s1 , Sub                              'jesli przycisk S1 impulsatora nacisniety to skok do podprogramu P_s1
Loop                                                        'koniec glownej petli do-loop
End                                                         'koniec programu

Sub Odczyt_zn                                               'procedura odczytu znakow nadawanych przez uklady slave
  Reset Watchdog                                            'zerowanie watchdog
  Czekaj = 0                                                'zerowanie zmiennej czekaj
  Zm_lan = ""                                               'czyszczenie zmiennej znakowej zm_lan
  Do                                                        'poczatek petli do-loop
    Incr Czekaj                                             'zwieksz o jeden zmienna czekaj
    Zn = Inkey()                                            'odczyt znaku z bufora rs232
    If Zn >= "-" And Zn <= "9" Then                         'jesli odczytany znak na kod ascii liczby z zakresu 0..9 to
      Zm_lan = Zm_lan + Zn                                  'dodaj odczytany znak do zmiennej zm_lan
    End If
    Reset Watchdog                                          'zerowanie watchdog
    Waitms 8                                                'czekaj 1ms
  Loop Until Zn = Chr(13) Or Czekaj > 250                   'petla wykonywana az otrzymano znak CR (ascii 13) lub zmienna czejaj> niz 100
End Sub                                                     'koniec procedury - odczytane dane zamiera zmienna zm_lan

P_s1:                                                       'podprogram obslugi przycisku S1
  Reset Watchdog                                            'zerowanie watchdog
  Reset U_par                                               'zerowanie flagi
  Cls                                                       'czysc lcd
  Lcd "T:" ; Temp_ust ; Chr(2) ; "C "                       'wyswietlenie temperatury termostatu
  Czysc                                                     'czysc vfd
  Wys_vfd "T:"                                              'wyswietlenie temperatury termostatu na vfd
  Zm_lan = Str(temp_ust)                                    'przeliczenie temp term
  Wys_st                                                    'wyslanie danych do vfd
  Licznik = 0                                               'zerowanie licznik
  Do                                                        'poczatek petli do
    Reset Watchdog                                          'zerowanie watchdog
    Waitms 10                                               'opoznienie 10 ms
    Incr Licznik                                            'zwieksz o 1 licznik
    If Licznik = 250 Then                                   'jesli licznik > 250 to
      Cls                                                   'czysc lcd
      Lcd "Konfig"                                          'wyswietl napis na lcd
      Czysc                                                 'czysc vfd
      Wys_vfd "Konfig"                                      'wyswietl napis na vfd
      Set U_par                                             'ustawienie flagi
    End If
  Loop Until S1 = 1                                         'petla wykonywana az S1=1
  If U_par = 0 Then                                         'jesli flaga=0 to
    Licznik = 0                                             'zerowanie zmiennej
    J = Temp_ust                                            'zapisanie do j wartosci zmiennej
    Do                                                      'poczatek petli do
      Reset Watchdog                                        'zerowanie watchdog
      Incr Licznik                                          'ikrementowanie licznik
      B = Encoder(pind.6 , Pind.5 , Lewo , Prawo , 0)       'odczyt danych z enkodera (impulsatora)
      If J > 40 Then                                        'jesli j>40 to
        J = 40                                              'zapis do j wartosci 40
      End If
      Temp_ust = J                                          'zapis j do zmiennej
      If Z_lcd = 1 Then                                     'jesli flaga=1 to
        Cls                                                 'czysc lcd
        Lcd "T:" ; Temp_ust ; Chr(2) ; "C "                 'wyswietlenie wartosci temperatury termostatu
        Pocz                                                'kursor na poczatek vfd
        Wys_vfd "T:"                                        'to samo dla VFD
        Zm_lan = Str(temp_ust)                              'przeliczenie wartosci
        Wys_st                                              'wyslanie do VFD
        Reset Z_lcd                                         'zerowanie flagi
      End If
      Reset Watchdog                                        'zerowanie watchdog
      Waitms 10                                             'opoznienie 10 ms
      If S1 = 0 Then                                        'jesli S1=0 (przycisniety) to
        Reset Watchdog                                      'zerowanie watchdog
        Waitms 30                                           'opoznienie 30 ms
        Exit Do                                             'wyjscie z petli do-loop
      End If
    Loop Until Licznik = 400                                'wyjscie z petli jeslicznik = 400
    Writeeeprom Temp_ust , 2                                'zapis danej do pamieci eeprom
  Else                                                      'w przeciwnym razie
    Reset Watchdog                                          'zerowanie watchdog
    Licznik = 0                                             'zerowanie licznik
    Set Z_lcd                                               'ustawienie flagi
    I = 1                                                   'zapis do i wartosci 1
    Tab_zm(1) = Adr_mod_tw                                  'zapis ustawianego parametru do tablicy 1
    Tab_zm(2) = Adr_mod_tz                                  'zapis ustawianego parametru do tablicy 2
    Tab_zm(3) = Adr_mod_wyk                                 'zapis ustawianego parametru do tablicy 3
    Tab_zm(4) = Tmp_termost                                 'zapis ustawianego parametru do tablicy 4
    Tab_zm(5) = Hist                                        'zapis ustawianego parametru do tablicy 5
    Tab_zm(6) = Podsw                                       'zapis ustawianego parametru do tablicy 6
    J = Tab_zm(i)                                           'zapis komorki tablicy do J
    Do                                                      'poczatek petli Do-loop
      Reset Watchdog                                        'zerowanie watchdog
      Waitms 10                                             'opoznienie 10 ms
    Loop Until S1 = 1                                       'jesli S1=1 to opuszczenie petli
    Do                                                      'poczatek petli do-loop
      Reset Watchdog                                        'zerowanie watchdog
      Incr Licznik                                          'zwiekszenie wartosci licznik o 1
      If S1 = 0 Then                                        'jesli S1=0 to
        Incr I                                              'inkremencja wartosci I
        Licznik = 0                                         'zerowanie licznik
        Set Z_lcd                                           'ustawienie flagi
        J = Tab_zm(i)                                       'zapis do J wartosci tablicy
        Waitms 50                                           'opoznienie 50 ms
        Do                                                  'poczatek petli do
          Reset Watchdog                                    'zerowanie watchdog
        Loop Until S1 = 1                                   'opuszczenie petli jesli S1 = 1
      End If
      If Z_lcd = 1 Then                                     'jesli flaga ustawiona to
        Reset Watchdog                                      'zerowanie watchdog
        Pocz                                                'kursor na poczatek vfd
        If I = 1 Then                                       'jesli i=1 to
          If J > 32 Then                                    'jesli j>32 to
            J = 32                                          'zapis do j wartosci 32
          End If
          Adr_mod_tw = J                                    'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Tw adr:" ; Adr_mod_tw                        'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Tw adr:"                                 'wyswietlenie ustawianego parametru na VFD
          Wys_zm_vfd                                        'wyslanie danych do VFD
          End If
        If I = 2 Then                                       'jesli i=2 to
          If J > 31 Then                                    'jesli j>31 to
            J = 31                                          'zapisz do j wartosc 31
          End If
          Adr_mod_tz = J                                    'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Tz adr:" ; Adr_mod_tz                        'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Tz adr:"                                 'wyswietlenie ustawianego parametru na VFD
          Wys_zm_vfd                                        'wyslanie danych do VFD
         End If
        If I = 3 Then                                       'jesli i=3 to
          If J > 31 Then                                    'jesli j>31 to
            J = 31                                          'zapisz do j wartosc 31
          End If
          Adr_mod_wyk = J                                   'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Pk adr:" ; Adr_mod_wyk                       'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Pk adr:"                                 'wyswietlenie ustawianego parametru na VFD
          Wys_zm_vfd                                        'wyslanie danych do VFD
        End If
        If I = 4 Then                                       'jesli i=4 to
          If J = 0 Then                                     'jesli j=0 to
            J = 1                                           'zapisz do j wartosc 1
          End If
          If J > 2 Then                                     'jesli j>2 to
            J = 2                                           'zapisz do j wartosc 2
          End If
          Tmp_termost = J                                   'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Term:T"                                      'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Term:T"                                   'wyswietlenie ustawianego parametru na VFD
          If Tmp_termost = 1 Then                           'jesli zmienna ma wartosc 1 to
            Lcd "w"                                         'wyswietlenie ustawianego parametru na LCD
            Wys_vfd "w"                                     'wyswietlenie ustawianego parametru na VFD
          Else                                              'w przeciwnym razie
            Lcd "z"                                         'wyswietlenie ustawianego parametru na LCD
            Wys_vfd "z"                                     'wyswietlenie ustawianego parametru na VFD
          End If
        End If
        If I = 5 Then                                       'jesli I=5 to
          If J = 0 Then                                     'jesli j=0 to
            J = 1                                           'zapis do j wartosci 1
          End If
          If J > 10 Then                                    'jesli j>10 to
            J = 10                                          'zapis do j wartosci 10
          End If
          Hist = J                                          'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Hist:" ; Hist                                'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Hist:"                                   'wyswietlenie ustawianego parametru na VFD
          Wys_zm_vfd                                        'wyslanie danych do VFD
        End If
        If I = 6 Then                                       'jesli i=6 to
          If J = 0 Then                                     'jesli j=0 to
            J = 1                                           'zapis do j wartosci 1
          End If
          If J > 8 Then                                     'jesli j>8 to
            J = 8                                           'zapis do j wartosci 8
          End If
          Podsw = J                                         'zapis wartosci J do zmiennej
          Cls                                               'czysc LCD
          Lcd "Podsw:" ; Podsw                              'wyswietlenie ustawianego parametru na LCD
          Wys_vfd "Podsw:"                                  'wyswietlenie ustawianego parametru na VFD
          Wys_zm_vfd                                        'wyslanie danych do VFD
          Pwm1a = Podsw * 31                                'zapis wartosc pwm dla podswietlenia lcd
          Jasn_zn Podsw                                     'zapis jasnosci znakow VFD
          Reset Watchdog                                    'zerowanie watchdog
        End If
        Reset Z_lcd                                         'zerowanie flagi
        Wys_vfd "  "                                        'wyslanie do VFD pustych znakow
      End If
      If I = 7 Then                                         'jesli i=7 to
        Exit Do                                             'wyjscie z petli do-loop
      End If
      B = Encoder(pind.6 , Pind.5 , Lewo , Prawo , 0)   'odczyt danych z enkodera (impulsatora)
      Tab_zm(i) = J                                         'zapis wartosci j do tablicy
      Waitms 10                                             'opoznienie 10 ms
      Reset Watchdog                                        'zerowanie watchdog
    Loop Until Licznik = 400                                'petla wykonywana az licznik = 400
    Writeeeprom Adr_mod_tw , 3                              'zapis danej do pamieci eeprom
    Writeeeprom Adr_mod_tz , 4                              'zapis danej do pamieci eeprom
    Writeeeprom Adr_mod_wyk , 5                             'zapis danej do pamieci eeprom
    Writeeeprom Tmp_termost , 6                             'zapis danej do pamieci eeprom
    Writeeeprom Hist , 7                                    'zapis danej do pamieci eeprom
    Writeeeprom Podsw , 8                                   'zapis danej do pamieci eeprom
  End If
  Cls                                                       'czysc LCD
  Czysc                                                     'czysc VFD
Return                                                      'powrot z podprogramu

Lewo:                                                       'podprogram obslugi impulsatora - kierunek lewo
  Licznik = 0                                               'zerowanie licznik
  If J < 50 Then                                            'jesli j < 50 to
    Incr J                                                  'zwieksz o jeden wartosc j
  End If
  Set Z_lcd                                                 'ustawienie flagi zezwolenia na aktualizacje LCD
Return                                                      'powrot z podprogramu

Prawo:                                                      'podprogram obslugi impulsatora - kierunek prawo
  Licznik = 0                                               'zerowanie licznik
  If J > 0 Then                                             'jesli j > 0 to
    Decr J                                                  'zmniejsz o jeden wartosc j
  End If
  Set Z_lcd                                                 'ustawienie flagi zezwolenia na aktualizacje LCD
Return                                                      'powrot z podprogramu

Sub Wys_st                                                  'wyswietla znak stopnia na VFD
  Wys_vfd Zm_lan                                            'wyslanie do VFD wartosci zmiennej
  Zapisz_vfd 144                                            'wyslanie znaku stopnia
  Wys_vfd "C "                                              'wyswietlenie znaku C
End Sub                                                     'powrot z procedury

Sub Zapisz_vfd(byval Wart As Byte)                          'definicja procedury, ktora wysyla wartosc do VFD
  Reset Watchdog                                            'zerowanie watchdog
  Shiftout Portb.4 , Portb.5 , Wart , 1                     'wysyla wartosc do VFD
  Waitms 1                                                  'opoznienie 1 ms
End Sub                                                     'powrot z procedury

Sub Wys_zm_vfd                                              'wysyla mzienna do VFD
  Zm_lan = Str(j )                                          'przeliczenie zmiennej
  Wys_vfd Zm_lan                                            'wyslanie zmiennej do VFD
End Sub                                                     'powrot z procedury

Sub Jasn_zn(byval Js As Byte)                               'definicja procedury, ktra okrela jasno wywietlanych znakw
 Decr Js                                                    'zmniejszenie o jeden wartoci Js
 If Js < 8 Then                                             'jeli otrzymana warto Js < od 8, to
  Js = Js + &B00001000                                      'dodanie do wartoci Js kodu komendy okrelajcej jasno znakw VFD
  Call Zapisz_vfd(js)                                       'wys-anie wartoci Js do VFD
 End If
End Sub                                                     'powrot z procedury

Sub Poz_kurs(byval Poz As Byte)                             'definicja procedury, ktra okrela pozycj kursora
  Decr Poz                                                  'zmniejszenie o jeden wartoci parametru Poz
  If Poz < 16 Then                                          'jeli Poz < od 17, to
    Poz = Poz + &B11100000                                  'dodanie do wartoci Poz kodu komendy okrelajcej pozycj
    Call Zapisz_vfd(poz)                                    'wys-anie wartoci Poz do VFD
  End If
End Sub                                                     'powrot z procedury

Sub Wys_vfd(byval S As String)                              'definicja procedury, ktra wywietla podany jako parametr -acuch tekstu
 Local Dl As Byte                                           'lokalna zmienna okrelajca d-ugo tekstu w -acuchu
 Local Znak As String * 20                                  'lokalna zmienna tekstowa do ktrej bdzie zapisywany pojedynczy znak z -acucha tekstu
 Dl = Len(s)                                                'zwraca d-ugo tekstu ze zmiennej S do zmiennej Dl
 For M = 1 To Dl                                            'ptla tyle razy wykonana si, ile jest znakw w -acuchu tekstu
  Znak = Mid(s , M )                                        'zapisanie do zmiennej Znak jednego znaku z tekstu S o pozycji okrelonej przez M
  Kod = Asc(znak)                                           'zamiana znaku w zmiennej Znak na jej kod ASCII zapisywany w zmiennej Kod
  Zapisz_vfd Kod                                            'wys-anie kodu ASCII znaku do wywietlacza VFD
 Next M                                                     'zwikszenie o 1 wartoci M
End Sub                                                     'powrot z procedury

Sub Znak_uz(byval Nr_zn As Byte , Byval Kol1 As Byte , Byval Kol2 As Byte , Byval Kol3 As Byte , Byval Kol4 As Byte , Byval Kol5 As Byte)       'definicja procedury, ktra definiuje znak uytkownika
 Call Zapisz_vfd(255)                                       'wys-anie komendy definiowania nowego znaku
 If Nr_zn < 16 Then                                         'jeli Nr_zn jest < od 16, to
  Call Zapisz_vfd(nr_zn)                                    'zapisanie numeru znaku do VFD
  Call Zapisz_vfd(kol1)                                     'zapisanie kodu kolumny 1 znaku do VFD
  Call Zapisz_vfd(kol2)                                     'zapisanie kodu kolumny 2 znaku do VFD
  Call Zapisz_vfd(kol3)                                     'zapisanie kodu kolumny 3 znaku do VFD
  Call Zapisz_vfd(kol4)                                     'zapisanie kodu kolumny 4 znaku do VFD
  Call Zapisz_vfd(kol5)                                     'zapisanie kodu kolumny 5 znaku do VFD
 End If
End Sub                                                     'powrot z procedury

Sub Pocz()                                                  'definicja procedury, ktra ustawia kursor na pocztku linii VFD
  Poz_kurs 1                                                'wywo-anie procedury ustawiajcej kursor na 1pozycji VFD
End Sub                                                     'koniec procedury

Sub Czysc()                                                 'definicja procedury, ktra czyci zawarto VFD
 For M = 1 To 16                                            'ptla wykonywana 16 razy
  Poz_kurs M                                                'pozycja kursora na pozycj zawart w M
   Zapisz_vfd 32                                            'zapisanie na pozycji wskazywanej przez M znaku spacji
 Next M                                                     'zwikszenie M o 1
 Call Pocz                                                  'kursor na pocztek linii
End Sub                                                     'powrot z procedury


